--- title: urlRedirectCreate - GraphQL Admin description: >- Creates a [`UrlRedirect`](https://shopify.dev/api/admin-graphql/latest/objects/UrlRedirect) object. api_version: 2026-01 api_name: admin type: mutation api_type: graphql source_url: html: >- https://shopify.dev/docs/api/admin-graphql/latest/mutations/urlRedirectCreate md: >- https://shopify.dev/docs/api/admin-graphql/latest/mutations/urlRedirectCreate.md --- # url​Redirect​Create mutation Requires `write_online_store_navigation` access scope. Creates a [`UrlRedirect`](https://shopify.dev/api/admin-graphql/latest/objects/UrlRedirect) object. ## Arguments * url​Redirect [Url​Redirect​Input!](https://shopify.dev/docs/api/admin-graphql/latest/input-objects/UrlRedirectInput) required The fields to use when creating the redirect. *** ## Url​Redirect​Create​Payload returns * url​Redirect [Url​Redirect](https://shopify.dev/docs/api/admin-graphql/latest/objects/UrlRedirect) The created redirect. * user​Errors [\[Url​Redirect​User​Error!\]!](https://shopify.dev/docs/api/admin-graphql/latest/objects/UrlRedirectUserError) non-null The list of errors that occurred from executing the mutation. *** ## Examples * ### Creates a redirect #### Query ```graphql mutation UrlRedirectCreate($urlRedirect: UrlRedirectInput!) { urlRedirectCreate(urlRedirect: $urlRedirect) { urlRedirect { id path target } userErrors { field message } } } ``` #### Variables ```json { "urlRedirect": { "path": "/thepath", "target": "/thetarget" } } ``` #### cURL ```bash curl -X POST \ https://your-development-store.myshopify.com/admin/api/2026-01/graphql.json \ -H 'Content-Type: application/json' \ -H 'X-Shopify-Access-Token: {access_token}' \ -d '{ "query": "mutation UrlRedirectCreate($urlRedirect: UrlRedirectInput!) { urlRedirectCreate(urlRedirect: $urlRedirect) { urlRedirect { id path target } userErrors { field message } } }", "variables": { "urlRedirect": { "path": "/thepath", "target": "/thetarget" } } }' ``` #### React Router ```javascript import { authenticate } from "../shopify.server"; export const loader = async ({request}) => { const { admin } = await authenticate.admin(request); const response = await admin.graphql( `#graphql mutation UrlRedirectCreate($urlRedirect: UrlRedirectInput!) { urlRedirectCreate(urlRedirect: $urlRedirect) { urlRedirect { id path target } userErrors { field message } } }`, { variables: { "urlRedirect": { "path": "/thepath", "target": "/thetarget" } }, }, ); const json = await response.json(); return json.data; } ``` #### Ruby ```ruby session = ShopifyAPI::Auth::Session.new( shop: "your-development-store.myshopify.com", access_token: access_token ) client = ShopifyAPI::Clients::Graphql::Admin.new( session: session ) query = <<~QUERY mutation UrlRedirectCreate($urlRedirect: UrlRedirectInput!) { urlRedirectCreate(urlRedirect: $urlRedirect) { urlRedirect { id path target } userErrors { field message } } } QUERY variables = { "urlRedirect": { "path": "/thepath", "target": "/thetarget" } } response = client.query(query: query, variables: variables) ``` #### Node.js ```javascript const client = new shopify.clients.Graphql({session}); const data = await client.query({ data: { "query": `mutation UrlRedirectCreate($urlRedirect: UrlRedirectInput!) { urlRedirectCreate(urlRedirect: $urlRedirect) { urlRedirect { id path target } userErrors { field message } } }`, "variables": { "urlRedirect": { "path": "/thepath", "target": "/thetarget" } }, }, }); ``` #### Shopify CLI ```bash shopify app execute \ --query \ 'mutation UrlRedirectCreate($urlRedirect: UrlRedirectInput!) { urlRedirectCreate(urlRedirect: $urlRedirect) { urlRedirect { id path target } userErrors { field message } } }' \ --variables \ '{ "urlRedirect": { "path": "/thepath", "target": "/thetarget" } }' ``` #### Response ```json { "urlRedirectCreate": { "urlRedirect": { "id": "gid://shopify/UrlRedirect/984542199", "path": "/thepath", "target": "/thetarget" }, "userErrors": [] } } ``` * ### urlRedirectCreate reference